"use strict";Object.defineProperty(exports,"__esModule",{value:!0}),exports.default=blossom;var _min=_interopRequireDefault(require("./min.js")),_rotate=_interopRequireDefault(require("./rotate.js")),_verifyOptimum=_interopRequireDefault(require("./verifyOptimum.js")),_checkDelta=_interopRequireDefault(require("./checkDelta2.js")),_checkDelta2=_interopRequireDefault(require("./checkDelta3.js")),_statistics3=_interopRequireDefault(require("./statistics.js")),_endpoints=_interopRequireDefault(require("./endpoints.js")),_neighbours=_interopRequireDefault(require("./neighbours.js")),_blossomLeaves=_interopRequireDefault(require("./blossomLeaves.js")),_blossomEdges=_interopRequireDefault(require("./blossomEdges.js"));function _interopRequireDefault(a){return a&&a.__esModule?a:{default:a}}function _createForOfIteratorHelper(a,b){var c="undefined"!=typeof Symbol&&a[Symbol.iterator]||a["@@iterator"];if(!c){if(Array.isArray(a)||(c=_unsupportedIterableToArray(a))||b&&a&&"number"==typeof a.length){c&&(a=c);var d=0,e=function(){};return{s:e,n:function n(){return d>=a.length?{done:!0}:{done:!1,value:a[d++]}},e:function e(a){throw a},f:e}}throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}var f,g=!0,h=!1;return{s:function s(){c=c.call(a)},n:function n(){var a=c.next();return g=a.done,a},e:function e(a){h=!0,f=a},f:function f(){try{g||null==c.return||c.return()}finally{if(h)throw f}}}}function _slicedToArray(a,b){return _arrayWithHoles(a)||_iterableToArrayLimit(a,b)||_unsupportedIterableToArray(a,b)||_nonIterableRest()}function _nonIterableRest(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}function _unsupportedIterableToArray(a,b){if(a){if("string"==typeof a)return _arrayLikeToArray(a,b);var c=Object.prototype.toString.call(a).slice(8,-1);return"Object"===c&&a.constructor&&(c=a.constructor.name),"Map"===c||"Set"===c?Array.from(a):"Arguments"===c||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(c)?_arrayLikeToArray(a,b):void 0}}function _arrayLikeToArray(a,b){(null==b||b>a.length)&&(b=a.length);for(var c=0,d=Array(b);c<b;c++)d[c]=a[c];return d}function _iterableToArrayLimit(a,b){var c=null==a?null:"undefined"!=typeof Symbol&&a[Symbol.iterator]||a["@@iterator"];if(null!=c){var d,e,f=[],g=!0,h=!1;try{for(c=c.call(a);!(g=(d=c.next()).done)&&(f.push(d.value),!(b&&f.length===b));g=!0);}catch(a){h=!0,e=a}finally{try{g||null==c["return"]||c["return"]()}finally{if(h)throw e}}return f}}function _arrayWithHoles(a){if(Array.isArray(a))return a}// Adapted from http://jorisvr.nl/maximummatching.html
// All credit for the implementation goes to Joris van Rantwijk [http://jorisvr.nl].
// ** Original introduction below **
// Weighted maximum matching in general graphs.
// The algorithm is taken from "Efficient Algorithms for Finding Maximum
// Matching in Graphs" by Zvi Galil, ACM Computing Surveys, 1986.
// It is based on the "blossom" method for finding augmenting paths and
// the "primal-dual" method for finding a matching of maximum weight, both
// due to Jack Edmonds.
// Some ideas came from "Implementation of algorithms for maximum matching
// on non-bipartite graphs" by H.J. Gabow, Standford Ph.D. thesis, 1973.
// A C program for maximum weight matching by Ed Rothberg was used extensively
// to validate this new code.
function blossom(a,b){b===void 0&&(b=!1),a===void 0&&(a=!0);/**
	 * Compute a maximum-weighted matching in the general undirected
	 * weighted graph given by "edges". If "maxCardinality" is true,
	 * only maximum-cardinality matchings are considered as solutions.
	 *
	 * Edges is a sequence of tuples (i, j, wt) describing an undirected
	 * edge between vertex i and vertex j with weight wt.  There is at most
	 * one edge between any two vertices; no vertex has an edge to itthis.
	 * Vertices are identified by consecutive, non-negative integers.
	 *
	 * Return a list "mate", such that mate[i] === j if vertex i is
	 * matched to vertex j, and mate[i] === -1 if vertex i is not matched.
	 *
	 * This function takes time O(n^3)
	 *
	 * @param {Array} edges
	 * @param {Boolean} maxCardinality
	 * @return {Array}
	 */var c=function(c){var e=!!(1<arguments.length&&arguments[1]!==void 0)&&arguments[1];// Vertices are numbered 0 .. (nvertex-1).
// Non-trivial blossoms are numbered nvertex .. (2*nvertex-1)
//
// Edges are numbered 0 .. (nedge-1).
// Edge endpoints are numbered 0 .. (2*nedge-1), such that endpoints
// (2*k) and (2*k+1) both belong to edge k.
//
// Many terms used in the comments (sub-blossom, T-vertex) come from
// the paper by Galil; read the paper before reading this code.
// Deal swiftly with empty graphs.
if(0===c.length)return[];// Count vertices + find the maximum edge weight.
for(var f=(0,_statistics3.default)(c),g=_slicedToArray(f,3),h=g[0],j=g[1],l=g[2],m=(0,_endpoints.default)(j,c),n=(0,_neighbours.default)(h,j,c),o=Array(h).fill(-1),q=Array(2*h).fill(0),r=Array(2*h).fill(-1),u=Array(h),x=0;x<h;++x)u[x]=x;// If b is a sub-blossom,
// blossomparent[b] is its immediate parent (sub-)blossom.
// If b is a top-level blossom, blossomparent[b] is -1.
for(var y=Array(2*h).fill(-1),A=Array(2*h).fill(null),B=Array(2*h),C=0;C<h;++C)B[C]=C;B.fill(-1,h,2*h);for(var D=Array(2*h).fill(null),E=Array(2*h).fill(-1),F=Array(2*h).fill(null),G=Array(h),H=0;H<h;++H)G[H]=h+H;// If v is a vertex,
// dualvar[v] = 2 * u(v) where u(v) is the v's variable in the dual
// optimization problem (multiplication by two ensures integer values
// throughout the algorithm if all edge weights are integers).
// If b is a non-trivial blossom,
// dualvar[b] = z(b) where z(b) is b's variable in the dual optimization
// problem.
var I=Array(2*h);I.fill(l,0,h),I.fill(0,h,2*h);// Main loop: continue until no further improvement is possible.
for(var J,s,z,K,L,M,N,O=Array(j).fill(!1),P=[],Q=function(a){var b=_slicedToArray(c[a],3),d=b[0],e=b[1],f=b[2];return I[d]+I[e]-2*f},R=function(a,c,d){var e=u[a];if(q[a]=c,q[e]=c,r[a]=d,r[e]=d,E[a]=-1,E[e]=-1,1===c){// B became an S-vertex/blossom; add it(s vertices) to the queue.
var b,f=_createForOfIteratorHelper((0,_blossomLeaves.default)(h,A,e));try{for(f.s();!(b=f.n()).done;){var g=b.value;P.push(g)}}catch(a){f.e(a)}finally{f.f()}}else{// B became a T-vertex/blossom; assign label S to its mate.
// (If b is a non-trivial blossom, its base is the only vertex
// with an external mate.)
var i=B[e];R(m[o[i]],1,1^o[i])}},S=function(a,c){// Trace back from v and w, placing breadcrumbs as we go.
for(var d,e=[],f=-1;-1!==a||-1!==c;){if(d=u[a],4&q[d]){f=B[d];break}// Swap v and w so that we alternate between both paths.
if(e.push(d),q[d]=5,-1===r[d]?a=-1:(a=m[r[d]],d=u[a],a=m[r[d]]),-1!==c){var j=a;a=c,c=j}}// Remove breadcrumbs.
for(var g,h=0,i=e;h<i.length;h++)g=i[h],q[g]=1;// Return base vertex, if we found one.
return f},T=function(a,d){var e=c[d][0],f=c[d][1],g=u[a],i=u[e],l=u[f],o=G.pop();B[o]=a,y[o]=-1,y[g]=o;// Make list of sub-blossoms and their interconnecting edge endpoints.
var b=[];A[o]=b;var p=[];// Trace back from v to base.
for(D[o]=p;i!==g;)// Add bv to the new blossom.
y[i]=o,b.push(i),p.push(r[i]),e=m[r[i]],i=u[e];// Reverse lists, add endpoint that connects the pair of S vertices.
// Trace back from w to base.
for(b.push(g),b.reverse(),p.reverse(),p.push(2*d);l!==g;)// Add bw to the new blossom.
y[l]=o,b.push(l),p.push(1^r[l]),f=m[r[l]],l=u[f];// Set label to S.
q[o]=1,r[o]=r[g],I[o]=0;// Relabel vertices.
var s,t=_createForOfIteratorHelper((0,_blossomLeaves.default)(h,A,o));try{for(t.s();!(s=t.n()).done;){var W=s.value;2===q[u[W]]&&P.push(W),u[W]=o}// Compute blossombestedges[b].
}catch(a){t.e(a)}finally{t.f()}for(var x=Array(2*h).fill(-1),C=b.length,H=0;H<C;++H){var J=b[H],K=F[J];// Walk this subblossom's least-slack edges.
null===K&&(K=(0,_blossomEdges.default)(h,A,n,J));var L,M=_createForOfIteratorHelper(K);try{for(M.s();!(L=M.n()).done;){var N=L.value,O=_slicedToArray(c[N],2),R=O[0],S=O[1],j=u[S]===o?u[R]:u[S];j!==o&&1===q[j]&&(-1===x[j]||Q(N)<Q(x[j]))&&(x[j]=N)}// Forget about least-slack edges of the subblossom.
}catch(a){M.e(a)}finally{M.f()}F[J]=null,E[J]=-1}F[o]=[];for(var T=x.length,U=0;U<T;++U)d=x[U],-1!==d&&F[o].push(d);// Select bestedge[b].
var V=F[o].length;if(0<V){E[o]=F[o][0];for(var X=1;X<V;++X)d=F[o][X],Q(d)<Q(E[o])&&(E[o]=d)}else E[o]=-1},U=function(a,b){// Convert sub-blossoms into top-level blossoms.
for(var w,s=0;s<A[a].length;++s)if(w=A[a][s],y[w]=-1,w<h)u[w]=w;else if(b&&0===I[w])// Recursively expand this sub-blossom.
U(w,b);else{var c,d=_createForOfIteratorHelper((0,_blossomLeaves.default)(h,A,w));try{for(d.s();!(c=d.n()).done;){var x=c.value;u[x]=w}}catch(a){d.e(a)}finally{d.f()}}// If we expand a T-blossom during a stage, its sub-blossoms must be
// relabeled.
if(!b&&2===q[a]){// Start at the sub-blossom through which the expanding
// blossom obtained its label, and relabel sub-blossoms untili
// we reach the base.
// Figure out through which sub-blossom the expanding blossom
// obtained its label initially.
var e,f,g,i,k=u[m[1^r[a]]],l=A[a].indexOf(k);// Decide in which direction we will go round the blossom.
1&l?(e=1,f=0,g=A[a].length,i=0):(e=-1,f=1,g=0,i=A[a].length);for(// Move along the blossom until we get to the base.
var v=r[a];l!==g;)// Relabel the T-sub-blossom.
// Step to the next S-sub-blossom and note its forward endpoint.
// Step to the next T-sub-blossom.
q[m[1^v]]=0,q[m[1^(D[a][l-f]^f)]]=0,R(m[1^v],2,v),O[Math.floor(D[a][l-f]/2)]=!0,l+=e,v=D[a][l-f]^f,O[Math.floor(v/2)]=!0,l+=e;// Relabel the base T-sub-blossom WITHOUT stepping through to
// its mate (so don't call assignLabel).
var p=A[a][0];for(q[m[1^aa]]=2,q[p]=2,r[m[1^aa]]=aa,r[p]=aa,E[p]=-1,l=i+e;A[a][l]!==k;){if(p=A[a][l],1===q[p]){l+=e;continue}var n,t=_createForOfIteratorHelper((0,_blossomLeaves.default)(h,A,p));try{for(t.s();!(n=t.n()).done;){var z=n.value;if(0!==q[z]){q[z]=0,q[m[o[B[p]]]]=0,R(z,2,r[z]);break}// If the sub-blossom contains a reachable vertex, assign
// label T to the sub-blossom.
}}catch(a){t.e(a)}finally{t.f()}l+=e}}// Recycle the blossom number.
q[a]=-1,r[a]=-1,A[a]=null,D[a]=null,B[a]=-1,F[a]=null,E[a]=-1,G.push(a)},V=function(a,b){// Bubble up through the blossom tree from vertex v to an immediate
// sub-blossom of b.
for(var c,d,e,f,g,k=b;y[k]!==a;)k=y[k];// Recursively deal with the first sub-blossom.
k>=h&&V(k,b),c=A[a].indexOf(k);var l=c,i=A[a].length;// Move along the blossom until we get to the base.
for(1&l?(d=1,e=0,f=i):(d=-1,e=1,f=0);c!==f;)// Step to the next sub-blossom and augment it recursively.
// Step to the next sub-blossom and augment it recursively.
// Match the edge connecting those sub-blossoms.
c+=d,k=A[a][c],g=D[a][c-e]^e,k>=h&&V(k,m[g]),c+=d,k=A[a][Math.abs(c%i)],k>=h&&V(k,m[1^g]),o[m[g]]=1^g,o[m[1^g]]=g;// Rotate the list of sub-blossoms to put the new base at the front.
(0,_rotate.default)(A[a],l),(0,_rotate.default)(D[a],l),B[a]=B[A[a][0]]},W=function(a){var b=c[a][0],d=c[a][1];X(b,2*a+1),X(d,2*a)},X=function(a,b){// Match vertex s to remote endpoint p. Then trace back from s
// until we find a single vertex, swapping matched and unmatched
// edges as we go.
// eslint-disable-next-line no-constant-condition
for(;;){var e=u[a];// Trace one step back.
if(e>=h&&V(e,a),o[a]=b,-1===r[e])// Reached single vertex; stop.
break;var c=m[r[e]],d=u[c];a=m[r[d]];var f=m[1^r[d]];// Augment through the T-blossom from j to base.
d>=h&&V(d,f),o[f]=r[d],b=1^r[d]}},Y=0;Y<h;++Y){q.fill(0),E.fill(-1),F.fill(null,h,2*h),O.fill(!1),P=[];// Label single blossoms/vertices with S and put them in the queue.
for(var w=0;w<h;++w)-1===o[w]&&0===q[u[w]]&&R(w,1,-1);// Loop until we succeed in augmenting the matching.
// eslint-disable-next-line no-constant-condition
for(var v=!1;;){// Each iteration of this loop is a "substage".
// A substage tries to find an augmenting path;
// if found, the path is used to improve the matching and
// the stage ends. If there is no augmenting path, the
// primal-dual method is used to pump some slack out of
// the dual variables.
// Continue labeling until all vertices which are reachable
// through an alternating path have got a label.
for(;0<P.length&&!v;)// Take an S vertex from the queue.
for(var Z=P.pop(),$=n[Z].length,_=0;_<$;++_){var aa=n[Z][_],p=Math.floor(aa/2),k=m[aa];// W is a neighbour to v
if(u[Z]!==u[k])// This edge is internal to a blossom; ignore it
if(O[p]||(s=Q(p),0>=s&&(O[p]=!0)),O[p]){if(0===q[u[k]])R(k,2,1^aa);else if(1!==q[u[k]])0===q[k]&&(// W is inside a T-blossom, but w itthis has not
// yet been reached from outside the blossom;
// mark it as reached (we need this to relabel
// during T-blossom expansion).
q[k]=2,r[k]=1^aa);else if(z=S(Z,k),0<=z)T(z,p);else{W(p),v=!0;break}}else if(1===q[u[k]]){// Keep track of the least-slack non-allowable edge to
// a different S-blossom.
var ba=u[Z];(-1===E[ba]||s<Q(E[ba]))&&(E[ba]=p)}else 0===q[k]&&(-1===E[k]||s<Q(E[k]))&&(E[k]=p)}if(v)break;// There is no augmenting path under these constraints;
// compute delta and reduce slack in the optimization problem.
// (Note that our vertex dual variables, edge slacks and delta's
// are pre-multiplied by two.)
K=-1,L=null,M=null,N=null,b&&((0,_checkDelta.default)({nvertex:h,neighbend:n,label:q,endpoint:m,bestedge:E,slack:Q,inblossom:u}),(0,_checkDelta2.default)({nvertex:h,edges:c,blossomparent:y,blossomchilds:A,neighbend:n,label:q,endpoint:m,bestedge:E,slack:Q,inblossom:u})),e||(K=1,L=(0,_min.default)(I,0,h));// Compute delta2: the minimum slack on any edge between
// an S-vertex and a free vertex.
for(var b=0;b<h;++b)0===q[u[b]]&&-1!==E[b]&&(J=Q(E[b]),(-1===K||J<L)&&(L=J,K=2,M=E[b]));// Compute delta3: half the minimum slack on any edge between
// a pair of S-blossoms.
for(var ca=0;ca<2*h;++ca)-1===y[ca]&&1===q[ca]&&-1!==E[ca]&&(s=Q(E[ca]),J=s/2,(-1===K||J<L)&&(L=J,K=3,M=E[ca]));// Compute delta4: minimum z variable of any T-blossom.
for(var da=h;da<2*h;++da)0<=B[da]&&-1===y[da]&&2===q[da]&&(-1===K||I[da]<L)&&(L=I[da],K=4,N=da);-1===K&&(K=1,L=Math.max(0,(0,_min.default)(I,0,h)));// Update dual variables according to delta.
for(var ea=0;ea<h;++ea)1===q[u[ea]]?// S-vertex: 2*u = 2*u - 2*delta
I[ea]-=L:2===q[u[ea]]&&(// T-vertex: 2*u = 2*u + 2*delta
I[ea]+=L);for(var fa=h;fa<2*h;++fa)0<=B[fa]&&-1===y[fa]&&(1===q[fa]?I[fa]+=L:2===q[fa]&&(I[fa]-=L));// Take action at the point where minimum delta occurred.
if(1===K)// No further improvement possible; optimum reached.
break;else if(2===K){O[M]=!0;var ga=c[M][0];0===q[u[ga]]&&(ga=c[M][1]),P.push(ga)}else if(3===K){O[M]=!0;var ha=c[M][0];P.push(ha)}else// Expand the least-z blossom.
U(N,!1)}// End of a this substage.
// Stop when no more augmenting path can be found.
if(!augmented)break;// End of a stage; expand all S-blossoms which have dualvar = 0.
for(var ia=h;ia<2*h;++ia)-1===y[ia]&&0<=B[ia]&&1===q[ia]&&0===I[ia]&&U(ia,!0)}// Verify that we reached the optimum solution.
a&&(0,_verifyOptimum.default)({nvertex:h,edges:c,maxCardinality:e,nedge:j,blossomparent:y,mate:o,endpoint:m,dualvar:I,blossombase:B,blossomendps:D});// Transform mate[] such that mate[v] is the vertex to which v is paired.
for(var ja=0;ja<h;++ja)0<=o[ja]&&(o[ja]=m[o[ja]]);for(var ka=0;ka<h;++ka);return o};return c}
//# sourceMappingURL=blossom.js.map